@echo off
setlocal enabledelayedexpansion
set SCRIPTDIR=C:\ccs\
set SCRIPTNAME=addroutes.bat

echo.
echo ***********************************************************************
echo *****************  CCS Fax PC Static Routes Script  *******************
echo ***********************************************************************
echo.
echo First things first, let's view the current routing table to see 
echo if there are any current IPv4 Rersistent Routes already.
echo.
echo Press enter when ready.
pause >nul
netstat -rn

:MENU
echo.
echo ***********************************************************************
echo *****************  CCS Fax PC Static Routes Script  *******************
echo ***********************************************************************
echo _______________________________________________________________________
echo.
echo 1 - Add Multiple Routes - Fresh New Config (MEDENT Server + Fax PC NAT)
echo 2 - Add Route(s)        - MEDENT Cloud Server(s) Only       - 10.45.x.x
echo 3 - Add Route(s)        - Fax PC(s) NAT Only                - 172.x.x.x
echo 4 - Show Current Routing Table
echo 5 - Exit Script
echo _______________________________________________________________________
echo.
set /P M="---> Choose an option then hit ENTER: "
if %M%==1 call:FRESHSTART
if %M%==2 call:CLOUDVMONLY
if %M%==3 call:CLOUDNATONLY
if %M%==4 call:RUNNETSTAT
if %M%==5 exit /b

exit /B %errorlevel%

:: Functions

:FRESHSTART
call:CHECKFORADDROUTESBAT
call:CLOUDVMANDNAT
call:VERIFYNETSTAT
call:VERIFYADDROUTESBAT
call:CREATETASK
call:MENU
exit /B

:CLOUDVMONLY
call:CLOUDVM
call:VERIFYNETSTAT
call:VERIFYADDROUTESBAT
call:CREATETASK
call:MENU
exit /B

:CLOUDNATONLY
call:CLOUDNAT
call:VERIFYNETSTAT
call:VERIFYADDROUTESBAT
call:CREATETASK
call:MENU
exit /B

:RUNNETSTAT
netstat -rn
call:MENU
exit /b

:CHECKFORADDROUTESBAT
echo.
echo Checking for an existing addroutes.bat script in %SCRIPTDIR%...
echo.
if exist %SCRIPTDIR%%SCRIPTNAME% (
    echo.
    echo ***WARNING*** An existing c:\ccs\bin\addroutes.bat already exists.
    echo.
    echo Backing up existing one for future reference and creating a new one...
	echo.
	if exist %SCRIPTDIR%%SCRIPTNAME%.BU (
		del %SCRIPTDIR%%SCRIPTNAME%.BU
	)
	ren %SCRIPTDIR%%SCRIPTNAME% %SCRIPTNAME%.BU
	echo @echo off>>"%SCRIPTDIR%%SCRIPTNAME%"
) else (
    echo No existing script found, creating base script now...
	echo @echo off>>"%SCRIPTDIR%%SCRIPTNAME%"
)   
exit /B

:CLOUDVMANDNAT
echo _____________________________________________________________
echo.
echo ##### Route to Client's MEDENT Cloud Server (10.45.x.x) #####
echo #####                   +
echo ##### Route for Client's Fax PC NAT Address (172.x.x.x) #####
echo _____________________________________________________________
echo.
set /p IPCLOUDVM=" ---> Enter Client's MEDENT Cloud Server IP (10.45.x.x): "
echo.
set /p IPCLOUDNAT=" ---> Enter Client's Fax PC NAT IP: "
echo.
set /p IPFAXRTR=" ---> Enter Client's Fax Router IP: " 
echo.
echo Checking route table to see if cloud server route exists already...
echo.
REM old method - netstat -rn | findstr /X /C:"    65.114.41.100  255.255.255.255      %IPPROX%       1"
REM route print 65.114.41.100 | findstr /R /C:"\<65.114.41.100" | findstr /R /C:"%IPPROX%" | findstr /R /C:"1\>"
reg query HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Services\Tcpip\Parameters\PersistentRoutes /f %IPCLOUDVM%,255.255.255.255,%IPFAXRTR%,
IF %ERRORLEVEL% EQU 1 (
	echo Route does not exist.
	call:ADD1045ROUTE
	echo.
	set /p INPUT=" ---> Any additional MEDENT Cloud Server IP's needed? (Y/N) "
	If /i "!INPUT!" == "y" call:CLOUDVMEXTRA
    If /i "!INPUT!" == "n" echo "Moving on to Fax PC NAT route(s)"
) else (
	echo Route already exists.
	echo.
	echo Adding route statement to %SCRIPTDIR%%SCRIPTNAME% startup script.
	echo route -p add %IPCLOUDVM% mask 255.255.255.255 %IPFAXRTR%>>"%SCRIPTDIR%%SCRIPTNAME%"
	echo.
	set /p INPUT=" ---> Any additional MEDENT Cloud Server IP's needed? (Y/N) "
	If /i "!INPUT!" == "y" call:CLOUDVMEXTRA
    If /i "!INPUT!" == "n" echo "Moving on to Fax PC NAT route(s)"
)
echo.
echo Checking route table to see if Fax PC NAT route exists already...
echo.
REM old method - netstat -rn | findstr /X /C:"    65.114.41.100  255.255.255.255      %IPPROX%       1"
REM route print 65.114.41.100 | findstr /R /C:"\<65.114.41.100" | findstr /R /C:"%IPPROX%" | findstr /R /C:"1\>"
reg query HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Services\Tcpip\Parameters\PersistentRoutes /f %IPCLOUDNAT%,255.255.255.255,%IPFAXRTR%,
IF %ERRORLEVEL% EQU 1 (
	echo Route does not exist.
	call:ADD172ROUTE
	echo.
	set /p INPUT="Any additional Fax PC NAT routes needed? (Y/N) "
	If /i "!INPUT!" == "y" call:CLOUDNATEXTRA
    If /i "!INPUT!" == "n" exit /B
) else (
	echo Route already exists.
	echo.
	echo Adding route statement to %SCRIPTDIR%%SCRIPTNAME% startup script.
	echo route -p add %IPCLOUDNAT% mask 255.255.255.255 %IPFAXRTR%>>"%SCRIPTDIR%%SCRIPTNAME%"
	echo.
	set /p INPUT=" ---> Any additional Fax PC NAT routes needed? (Y/N) "
	If /i "!INPUT!" == "y" call:CLOUDNATEXTRA
    If /i "!INPUT!" == "n" exit /B
)
exit /B

:CLOUDVM
echo _____________________________________________________________
echo.
echo ##### Route to Client's MEDENT Cloud Server (10.45.x.x) #####
echo _____________________________________________________________
echo.
set /p IPCLOUDVM=" ---> Enter Client's MEDENT Cloud Server IP (10.45.x.x): "
echo.
set /p IPFAXRTR=" ---> Enter Client's Fax Router IP: " 
echo.
echo Checking route table to see if it exists already...
echo.
REM old method - netstat -rn | findstr /X /C:"    65.114.41.100  255.255.255.255      %IPPROX%       1"
REM route print 65.114.41.100 | findstr /R /C:"\<65.114.41.100" | findstr /R /C:"%IPPROX%" | findstr /R /C:"1\>"
reg query HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Services\Tcpip\Parameters\PersistentRoutes /f %IPCLOUDVM%,255.255.255.255,%IPFAXRTR%,
IF %ERRORLEVEL%==1 (
	echo Route does not exist.
	call:ADD1045ROUTE
	echo.
	set /p INPUT=" ---> Any additional MEDENT Cloud Server IP's needed? (Y/N) "
	If /i "!INPUT!" == "y" call:CLOUDVMEXTRA
    If /i "!INPUT!" == "n" exit /B
) else (
	echo Route already exists.
	echo.
	echo Adding route statement to %SCRIPTDIR%%SCRIPTNAME% startup script.
	echo route -p add %IPCLOUDVM% mask 255.255.255.255 %IPFAXRTR%>>"%SCRIPTDIR%%SCRIPTNAME%"
	echo.
	set /p INPUT=" ---> Any additional MEDENT Cloud Server IP's needed? (Y/N) "
	If /i "!INPUT!" == "y" call:CLOUDVMEXTRA
    If /i "!INPUT!" == "n" exit /B
)
exit /B

:CLOUDVMEXTRA
echo ____________________________________________________________________ 
echo.
echo ### Additional Route for another MEDENT Cloud Server (10.45.x.x) ###
echo ____________________________________________________________________
echo.
set /p IPCLOUDVM=" ---> Enter Additional MEDENT Cloud Server IP (10.45.x.x): "
echo.
set /p IPFAXRTR=" ---> Enter Client's Fax Router IP: " 
echo.
echo Checking route table to see if it exists already...
echo.
REM old method - netstat -rn | findstr /X /C:"    65.114.41.100  255.255.255.255      %IPPROX%       1"
REM route print 65.114.41.100 | findstr /R /C:"\<65.114.41.100" | findstr /R /C:"%IPPROX%" | findstr /R /C:"1\>"
reg query HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Services\Tcpip\Parameters\PersistentRoutes /f %IPCLOUDVM%,255.255.255.255,%IPFAXRTR%,
IF %ERRORLEVEL%==1 (
	echo Route does not exist.
	call:ADD1045ROUTE
	echo.
	set /p INPUT=" ---> Any additional MEDENT Cloud Server IP's needed? (Y/N) "
	If /i "!INPUT!" == "y" call:CLOUDVMEXTRA
    If /i "!INPUT!" == "n" exit /B
) else (
	echo Route already exists.
	echo.
	echo Adding route statement to %SCRIPTDIR%%SCRIPTNAME% startup script.
	echo route -p add %IPCLOUDVM% mask 255.255.255.255 %IPFAXRTR%>>"%SCRIPTDIR%%SCRIPTNAME%"
	echo.
	set /p INPUT=" ---> Any additional MEDENT Cloud Server IP's needed? (Y/N) "
	If /i "!INPUT!" == "y" call:CLOUDVMEXTRA
    If /i "!INPUT!" == "n" exit /B
)
exit /B

:ADD1045ROUTE
echo.
echo Adding new static route for this machine for MEDENT 
echo communication to client's MEDENT Cloud Server
echo.
echo Route command used: 
echo route -p add %IPCLOUDVM% mask 255.255.255.255 %IPFAXRTR%
echo.
route -p add %IPCLOUDVM% mask 255.255.255.255 %IPFAXRTR%
echo.
echo Checking route table to verify route is included...
echo.
REM Old method - netstat -rn | findstr /X /C:"    65.114.41.100  255.255.255.255      %IPPROX%       1"
REM route print 65.114.41.100 | findstr /R /C:"\<65.114.41.100" | findstr /R /C:"%IPPROX%" | findstr /R /C:"1\>"
reg query HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Services\Tcpip\Parameters\PersistentRoutes /f %IPCLOUDVM%,255.255.255.255,%IPFAXRTR%,
IF %ERRORLEVEL%  EQU 1 (
	echo ..............................................................
	echo ...          ERROR! Persistent Route not found             ...
	echo ...       Please re run this script and try again.         ...
	echo ..............................................................
	exit /b
)
IF %ERRORLEVEL%==0 (
	echo.
	echo Verified! Persistent Route is now in the routing table.
	echo.
	echo Adding route statement to %SCRIPTDIR%%SCRIPTNAME% startup script.
	echo route -p add %IPCLOUDVM% mask 255.255.255.255 %IPFAXRTR%>>"%SCRIPTDIR%%SCRIPTNAME%"
)
exit /B

:CLOUDNAT
echo _______________________________________________________________ 
echo.
echo   ##### Route for Client's Fax PC NAT Address (172.x.x.x) #####
echo _______________________________________________________________
echo.
set /p IPCLOUDNAT=" ---> Enter Client's Fax PC NAT IP: "
echo.
set /p IPFAXRTR=" ---> Enter Client's Fax Router IP: "
echo.
echo Checking route table to see if it exists already...
echo.
REM old method - netstat -rn | findstr /X /C:"    65.114.41.100  255.255.255.255      %IPPROX%       1"
REM route print 65.114.41.100 | findstr /R /C:"\<65.114.41.100" | findstr /R /C:"%IPPROX%" | findstr /R /C:"1\>"
reg query HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Services\Tcpip\Parameters\PersistentRoutes /f %IPCLOUDNAT%,255.255.255.255,%IPFAXRTR%,
IF %ERRORLEVEL%==1 (
	echo Route does not exist.
	call:ADD172ROUTE
	echo.
	set /p INPUT="Any additional Fax PC NAT routes needed? (Y/N) "
	If /i "!INPUT!" == "y" call:CLOUDNATEXTRA
    If /i "!INPUT!" == "n" exit /B
) else (
	echo Route already exists.
	echo.
	echo Adding route statement to %SCRIPTDIR%%SCRIPTNAME% startup script.
	echo route -p add %IPCLOUDNAT% mask 255.255.255.255 %IPFAXRTR%>>"%SCRIPTDIR%%SCRIPTNAME%"
	echo.
	set /p INPUT=" ---> Any additional Fax PC NAT routes needed? (Y/N) "
	If /i "!INPUT!" == "y" call:CLOUDNATEXTRA
    If /i "!INPUT!" == "n" exit /B
)
exit /B

:CLOUDNATEXTRA
echo ______________________________________________________________________ 
echo.
echo ##### Additional Route for another Fax PC NAT address(172.x.x.x) #####
echo ______________________________________________________________________ 
echo.
set /p IPCLOUDNAT=" ---> Enter Client's Fax PC NAT IP: "
echo.
set /p IPFAXRTR=" ---> Enter Client's Fax Router IP: "
echo.
echo Checking route table to see if it exists already...
echo.
REM old method - netstat -rn | findstr /X /C:"    65.114.41.100  255.255.255.255      %IPPROX%       1"
REM route print 65.114.41.100 | findstr /R /C:"\<65.114.41.100" | findstr /R /C:"%IPPROX%" | findstr /R /C:"1\>"
reg query HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Services\Tcpip\Parameters\PersistentRoutes /f %IPCLOUDNAT%,255.255.255.255,%IPFAXRTR%,
IF %ERRORLEVEL%==1 (
	echo Route does not exist.
	call:ADD172ROUTE
	echo.
	set /p INPUT=" ---> Any additional Fax PC NAT routes needed? (Y/N) "
	If /i "!INPUT!" == "y" call:CLOUDNATEXTRA
    If /i "!INPUT!" == "n" exit /B
) else (
	echo Route already exists.
	echo.
	echo Adding route statement to %SCRIPTDIR%%SCRIPTNAME% startup script.
	echo route -p add %IPCLOUDNAT% mask 255.255.255.255 %IPFAXRTR%>>"%SCRIPTDIR%%SCRIPTNAME%"
	echo.
	set /p INPUT=" ---> Any additional Fax PC NAT routes needed? (Y/N) "
	If /i "!INPUT!" == "y" call:CLOUDNATEXTRA
    If /i "!INPUT!" == "n" exit /B
)
exit /B

:ADD172ROUTE
echo.
echo Adding new static route for this machine for MEDENT 
echo communication over client's assigned Fax PC NAT address
echo.
echo Route command used: 
echo route -p add %IPCLOUDNAT% mask 255.255.255.255 %IPFAXRTR%
echo.
route -p add %IPCLOUDNAT% mask 255.255.255.255 %IPFAXRTR%
echo.
echo Checking route table to verify Fax PC NAT route is now included...
echo.
REM Old method - netstat -rn | findstr /X /C:"    65.114.41.100  255.255.255.255      %IPPROX%       1"
REM route print 65.114.41.100 | findstr /R /C:"\<65.114.41.100" | findstr /R /C:"%IPPROX%" | findstr /R /C:"1\>"
reg query HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Services\Tcpip\Parameters\PersistentRoutes /f %IPCLOUDNAT%,255.255.255.255,%IPFAXRTR%,
IF %ERRORLEVEL%  EQU 1 (
	echo ..............................................................
	echo ...          ERROR! Persistent Route not found             ...
	echo ...       Please re run this script and try again.         ...
	echo ..............................................................
	exit /b
)
IF %ERRORLEVEL%==0 (
	echo.
	echo Verified! Persistent Route is now in the routing table.
	echo.
	echo Adding route statement to %SCRIPTDIR%%SCRIPTNAME% startup script.
	echo route -p add %IPCLOUDNAT% mask 255.255.255.255 %IPFAXRTR%>>"%SCRIPTDIR%%SCRIPTNAME%"
)
exit /B

:VERIFYNETSTAT
echo.
echo "--->  Press enter when ready to manually review the routing table to be sure all is well."
pause >nul
netstat -rn
exit /B

:CREATETASK
echo.
echo Checking for an existing "CCS AddRoutes" task in task scheduler...
echo.
schtasks /query /tn "CCS AddRoutes"
if %errorlevel% NEQ 0 (
	echo.
	echo Task not found, adding it now...
	echo.
	schtasks /create /xml c:\ccs\addroutes.xml /tn "CCS AddRoutes" /ru SYSTEM /f
	echo.
) else (
	echo.
	echo Task is already included in Scheduler.
)
exit /B

:VERIFYADDROUTESBAT
echo.
echo "--->  Press enter when ready to manually review the startup script to be sure all is well."
pause >nul
if exist %SCRIPTDIR%%SCRIPTNAME% (
	echo.
	echo Script contents below...
	echo.
	echo ............................................................
	type %SCRIPTDIR%%SCRIPTNAME%
	echo ............................................................
	echo.
) else (
	echo Something went wrong! No %SCRIPTDIR%%SCRIPTNAME% found. Please investigate.
)
exit /B

:EOF
cmd /k